#!/bin/sh
# Firmware Upgrade
# Editor: Jackie Chang

UPGRADE_PATH="/mnt/upgrade"
FILESYSTEM_UNZIP_TARGET="/mnt/user"

#================================
#	Copy upgrade script
#================================
# un-tar image
#mv $UPGRADE_PATH/upgrade.img $FILESYSTEM_UNZIP_TARGET/upgrade.tar.gz
#tar -C $UPGRADE_PATH -zxf $FILESYSTEM_UNZIP_TARGET/upgrade.tar.gz
#rm -f $FILESYSTEM_UNZIP_TARGET/upgrade.tar.gz

# Copy upgrade step script
#chmod 755 /usr/share/ti/dvsdk-demos/www/html/upgrade.sh
#cp -f $UPGRADE_PATH/ite-upgrade-HV/upgrade.sh /usr/share/ti/dvsdk-demos/www/html/


#==============================
#	Upgrade image
#==============================
# Update UBL
#nandwrite -s 0x20000 -p /dev/mtd0 /mnt/upgrade/virtual_sdcard_disk/ubl_nand.nandbin
# Update Uboot
#nandwrite -s 0x320000 -p /dev/mtd0 /mnt/upgrade/virtual_sdcard_disk/bootloader.nandbin

# Exception for avoid loading wrong upgrade image.
KERNEL_FILE=$UPGRADE_PATH/ite-upgrade-HV/kernel.uImage
if [ ! -f $KERNEL_FILE ]; then
	echo "$0: File '${KERNEL_FILE}' not found. Warning upgrade tar file!" > 'upgrade_log.txt'

	# Remove all upgrade file
	rm -f $UPGRADE_PATH/done
	rm -rf $UPGRADE_PATH/ite-upgrade-HV/
	rm -f $UPGRADE_PATH/lighttpd*
	rm -f $UPGRADE_PATH/cgi-upload*
	sync
	exit 0;
else
	echo "$0: File '${KERNEL_FILE}' found. Upgrading..." > 'upgrade_log.txt'

	# Update Kernel
	flash_erase /dev/mtd1 0x0 36 #37
	nandwrite -p /dev/mtd1 $UPGRADE_PATH/ite-upgrade-HV/kernel.uImage

	# Update Filesystem
	chmod 755 -R /etc/group
	chmod 755 -R /etc/group-
	chmod 755 -R /etc/passwd
	chmod 755 -R /etc/passwd-
	chmod 755 -R /usr/share/ti/dvsdk-demos/www/html/*
	chmod 755 -R $UPGRADE_PATH/ite-upgrade-HV/ite-tievmfs-leopard-nfs-upgrade/*
	chmod 755 -R $UPGRADE_PATH/ite-upgrade-HV/default/*		# default config
	chmod 755 -R $UPGRADE_PATH/ite-upgrade-HV/warning-screen-customize/*		# Warning_Customized.yuv
	cp -rf $UPGRADE_PATH/ite-upgrade-HV/ite-tievmfs-leopard-nfs-upgrade/* /
	cp -rf $UPGRADE_PATH/ite-upgrade-HV/default/* /mnt/default		# default config
	cp -rf $UPGRADE_PATH/ite-upgrade-HV/warning-screen-customize/* /usr/share/ti/dvsdk-demos/ite		# Warning_Customized.yuv
	chmod 644 -R /etc/group
	chmod 644 -R /etc/group-
	chmod 644 -R /etc/passwd
	chmod 644 -R /etc/passwd-
	chmod 644 /usr/share/ti/dvsdk-demos/www/html/av_control.js
	chmod 644 /usr/share/ti/dvsdk-demos/www/html/index.html
	chmod 644 /usr/share/ti/dvsdk-demos/www/html/index_redirect_test.html
	chmod 644 /usr/share/ti/dvsdk-demos/www/html/loadbar.gif
	chmod 644 /usr/share/ti/dvsdk-demos/www/html/cgi-bin/ccgi-1.2/*
	chmod 644 -R /usr/share/ti/dvsdk-demos/www/html/js/*
	chmod 644 -R /usr/share/ti/dvsdk-demos/www/html/css/*
	chmod 644 -R /usr/share/ti/dvsdk-demos/www/html/lang/*
	chmod 644 -R /mnt/default/*			# default config
fi

# Remove all upgrade file
rm -f $UPGRADE_PATH/done
rm -rf $UPGRADE_PATH/ite-upgrade-HV/
rm -f $UPGRADE_PATH/lighttpd*
rm -f $UPGRADE_PATH/cgi-upload*

sync

#############################################################################################################
#echo "Mount Virtual SD card image.._2" >> /upgrade_log.txt
#echo "Mount Virtual SD card image.."
# mount SD card image
#chmod 777 /mnt/upgrade/upgrade.img
#mount -o loop /mnt/upgrade/upgrade.img /mnt/upgrade/virtual_sdcard_disk	# ignore error message
#losetup -o 8225280 /dev/loop0 /mnt/upgrade/upgrade.img
#mount /dev/loop0 /mnt/upgrade/virtual_sdcard_disk

# Update UBL
#nandwrite -s 0x20000 -p /dev/mtd0 /mnt/upgrade/virtual_sdcard_disk/ubl_nand.nandbin
# Update Uboot
#nandwrite -s 0x320000 -p /dev/mtd0 /mnt/upgrade/virtual_sdcard_disk/bootloader.nandbin

# Update Kernel
#echo "Update Kernel.."
#nandwrite -p /dev/mtd1 /mnt/upgrade/virtual_sdcard_disk/kernel.uImage

# Update Filesystem
#echo "uzip upgrad image.."
#cp -af /mnt/upgrade/virtual_sdcard_disk/ite-tievmfs-leopard-nfs-upgrade.tar.gz /mnt/upgrade/
#tar -C /mnt/user/ -zxf /mnt/upgrade/ite-tievmfs-leopard-nfs-upgrade.tar.gz
#cp -rf /mnt/user/ite-tievmfs-leopard-nfs-upgrade/* /

#echo "Done!"
# Remove all upgrade file
#umount /mnt/upgrade/virtual_sdcard_disk
#rm -f /mnt/upgrade/ite-tievmfs-leopard-nfs-upgrade.tar.gz
#rm -rf /mnt/user/ite-tievmfs-leopard-nfs-upgrade
#rm -f /mnt/upgrade/upgrade.img
#rm -f /mnt/upgrade/lighttpd*
#rm -f /mnt/upgrade/cgi-upload*

